<script lang="ts" setup name="CustomerList">
import { getCurrentInstance, ref } from 'vue'
import type { Ref } from 'vue'
import type { DateModelType } from 'element-plus'
import { ElLoading, ElMessage, ElMessageBox } from 'element-plus'
import type { IAdvice, IAdviceQuery } from './advice_interface'
import type { TableColumn } from '@/components/NormalTable/table_interface'
import { printJSON } from '@/utils/printUtils'
import { exportFile } from '@/utils/exportUtils'
import { deleteAdvice, exportAdviceList, getAdviceList } from '@/api/customer/advice'
const { proxy } = getCurrentInstance() as any
const $router = useRouter()
// 查询条件
const listQuery: Ref<IAdviceQuery> = ref({
  adviceNo: '', // 投诉编号
  customerName: '', // 公司名称
  customerNo: '', // 客户编号
  startTime: '', // 投诉开始时间
  endTime: '', // 投诉结束时间
  formId: 'jlglsygfsp',
  offset: 1,
  limit: 20,
})
const timeRange = ref<[DateModelType, DateModelType]>(['', ''])
// 表头
const columns = ref<TableColumn[]>([
  { text: '投诉建议编号', value: 'adviceNo', width: '160', align: 'center' },
  { text: '客户编号', value: 'customerNo', width: '120', align: 'center' },
  { text: '客户名称', value: 'customerName', align: 'center' },
  { text: '整体评价', value: 'evaluationName', align: 'center' },
  { text: '投诉/建议内容', value: 'content', align: 'center' },
  { text: '投诉人', value: 'advicePerson', align: 'center' },
  { text: '联系方式', value: 'personPhone', align: 'center' },
  { text: '投诉时间', value: 'createTime', align: 'center', width: '180px' },
])
// 表格数据
const list = ref<IAdvice[]>([])
// 总数
const total = ref(0)
// 表格加载状态
const loadingTable = ref(false)
// 选中的内容
const checkoutList = ref<string[]>([])
// 文件上传input
const fileRef = ref()
// 数据查询
function fetchData(isNowPage = false) {
  loadingTable.value = true
  if (!isNowPage) {
    // 是否显示当前页，否则跳转第一页
    listQuery.value.offset = 1
  }
  listQuery.value.startTime = timeRange.value[0] as string || ''
  listQuery.value.endTime = timeRange.value[1] as string || ''
  getAdviceList(listQuery.value).then((response) => {
    // 模拟数据
    response.data.rows = [{ id: '1597579843411234817', advicePerson: '张三', personPhone: '87447', createTime: '2023-01-02 08:25:35', adviceNo: '111111', content: '服务态度不好', businessScope: 'test1', evaluation: '1', evaluationName: '优质', customerName: '京东集团', customerNo: 'sygf202211290001', updateTime: '2023-01-10 09:56:57' }]
    list.value = response.data.rows
    total.value = parseInt(response.data.total)
    loadingTable.value = false
  })
}
// 多选发生改变时
function handleSelectionChange(e: any) {
  checkoutList.value = e.map((item: { id: string }) => item.id)
}

// 点击编辑/详情
const handleEdit = (row: IAdvice, pageType: 'edit' | 'detail') => {
  $router.push(`/customerManage/advice/${pageType}/${row.id}`)
}
// 点击删除
const handleDelete = (index: string, row: IAdvice) => {
  ElMessageBox.confirm(
    `确认删除${row.customerName}吗？`,
    '提示',
    {
      confirmButtonText: '确认',
      cancelButtonText: '取消',
      type: 'warning',
    },
  )
    .then(() => {
      deleteAdvice({ id: row.id }).then((res) => {
        if (res.code === 200) {
          ElMessage({
            type: 'success',
            message: '删除成功',
          })
          fetchData(true)
        }
      })
    })
}
// 点击搜索
const searchList = () => {
  fetchData(true)
}
// 点击重置
const clearList = () => {
  listQuery.value = {
    adviceNo: '', // 投诉编号
    customerName: '', // 公司名称
    customerNo: '', // 客户编号
    startTime: '', // 投诉开始时间
    endTime: '', // 投诉结束时间
    offset: 1,
    limit: 20,
  }
}

// 上传文件/批量导入
const onFileChange = (event: any) => {
  // todo: 校验文件类型，调用上传接口
  if (event.target.files[0].type === 'application/pdf') {
    if (event.target.files?.length !== 0) {
      // 创建formdata对象
      // const fd = new FormData()
      // fd.append('multipartFile', event.target.files[0])
      // uploadApi(fd).then((res) => {
      //   if (res.code === 200) {
      //     ElMessage.success('上传成功')
      //   }
      //   else {
      //     ElMessage.error(res.message)
      //   }
      // })
    }
  }
  else {
    ElMessage.error('请上传pdf格式')
  }
}
// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number; page?: number }) => {
  if (val && val.size) {
    listQuery.value.limit = val.size
  }
  if (val && val.page) {
    listQuery.value.offset = val.page
  }
  fetchData(true)
}

// 点击批量导入
const uploadAll = () => {
  fileRef.value.click()
}
// 添加客户
const add = () => {
  $router.push('/customerManage/advice/add')
}
// 导出
const exportAll = () => {
  const loading = ElLoading.service({
    lock: true,
    text: '下载中请稍后',
    background: 'rgba(255, 255, 255, 0.8)',
  })
  if (list.value.length > 0) {
    const params = {
      adviceNo: listQuery.value.adviceNo, // 投诉编号
      customerName: listQuery.value.customerName, // 公司名称
      customerNo: listQuery.value.customerNo, // 客户编号
      startTime: listQuery.value.startTime, // 投诉开始时间
      endTime: listQuery.value.endTime, // 投诉结束时间
      ids: checkoutList.value,
    }
    exportAdviceList(params).then((res) => {
      const blob = new Blob([res.data])
      exportFile(blob, '客户关系.xlsx')
    })
  }
  else {
    ElMessage.warning('无数据可导出数据')
  }
  loading.close()
}

// 打印列表
function printList() {
  // 打印列
  const properties = columns.value.map((item) => {
    return {
      field: item.value,
      displayName: item.text,
    }
  })
  if (checkoutList.value.length <= 0 && list.value.length > 0) {
    printJSON(list.value, properties, '客户关系')
  }
  else if (checkoutList.value.length > 0) {
    const printList = list.value.filter((item: IAdvice) => checkoutList.value.includes(item.id))
    printJSON(printList, properties, '客户关系')
  }
  else {
    ElMessage.warning('无可打印内容')
  }
}

fetchData(true)
</script>

<template>
  <app-container>
    <search-area
      :need-clear="true"
      @search="searchList" @clear="clearList"
    >
      <search-item>
        <el-input
          v-model.trim="listQuery.customerNo"
          placeholder="投诉/建议编号"
          clearable
        />
      </search-item>
      <search-item>
        <el-input
          v-model.trim="listQuery.customerNo"
          placeholder="客户编号"
          clearable
        />
      </search-item>
      <search-item>
        <el-input
          v-model.trim="listQuery.customerName"
          placeholder="公司名称"
          clearable
        />
      </search-item>
      <search-item>
        <search-item>
          <el-date-picker
            v-model="timeRange"
            type="datetimerange"
            range-separator="到"
            format="YYYY/MM/DD HH:mm:ss"
            value-format="YYYY-MM-DD h:m:s"
            start-placeholder="投诉查询开始时间"
            end-placeholder="投诉查询结束时间"
          />
        </search-item>
      </search-item>
    </search-area>
    <table-container>
      <template #btns-right>
        <icon-button v-if="proxy.hasPerm('/meter/advice/import')" icon="icon-import" title="批量导入" type="primary" @click="uploadAll" />
        <icon-button v-if="proxy.hasPerm('/meter/advice/import')" icon="icon-template" title="模板下载" type="primary" />
        <icon-button v-if="proxy.hasPerm('/meter/advice/add')" icon="icon-add" title="新建" type="primary" @click="add" />
        <icon-button v-if="proxy.hasPerm('/meter/advice/export')" icon="icon-export" title="导出" type="primary" @click="exportAll" />
        <icon-button v-if="proxy.hasPerm('/meter/advice/print')" icon="icon-print" title="打印" type="primary" @click="printList" />
      </template>
      <input v-show="false" ref="fileRef" type="file" accept="*" @change="onFileChange">
      <normal-table
        :data="list" :total="total" :columns="columns" :query="listQuery"
        :list-loading="loadingTable" is-showmulti-select @change="changePage" @multi-select="handleSelectionChange"
      >
        <template #columns>
          <el-table-column label="操作" align="center" width="120">
            <template #default="{ row }">
              <el-button
                v-if="proxy.hasPerm('/meter/advice/update')"
                size="small"
                type="primary"
                link
                @click="handleEdit(row, 'edit')"
              >
                编辑
              </el-button>
              <el-button
                size="small"
                link
                type="primary"
                @click="handleEdit(row, 'detail')"
              >
                详情
              </el-button>
              <el-button
                v-if="proxy.hasPerm('/meter/advice/delete')"
                size="small"
                link
                type="danger"
                @click="handleDelete(row.$index, row)"
              >
                删除
              </el-button>
            </template>
          </el-table-column>
        </template>
      </normal-table>
    </table-container>
  </app-container>
</template>

<style lang="scss" scoped>
// 样式
</style>
